# Earth Defender

As the hero in Earth Defender, you have been commisioned by your king to defeat the monsters that have invaded earth and to find out who is behind all of this!

## Setting Up
1. Install python 3.9 or above
2. Create virtual environment 'venv'
```bash
    # Linux and MacOS
    python3 -m venv venv
    
    # Windows
    python -m venv venv
```
3. Activate virtual environment
```bash
    # Linux and MacOS
    source ./venv/bin/activate
    
    # Windows
    ./venv/Scripts/activate.bat
```
4. Install Requirements
```bash
    pip install -r requirements.txt
```
5. Run the game
```bash
    python src/main.py
```

## Game Controls

| Action                                 |      Keyboard     |     FabArcade     |
|----------------------------------------|:-----------------:|:-----------------:|
| Left                                   |  Arrow Key Left   |   Joystick Left   |
| Right                                  |  Arrow Key Right  |   Joystick Right  |
| Jump                                   |    Arrow Key Up   |        Blue       |
| Attack/Start/Confirm                   |       Space       |       Black       |
| Roll                                   |         a         |       Yellow      |
| Shield                                 |       L_Shift     |        Red        |
| Coin                                   |         c         |        Coin       |
| Pause/Back                             |        Esc        |        Menu       |

## Resources

### FONT
Silkscreen - https://www.fontsquirrel.com/fonts/Silkscreen

### IMAGES
Player and Enemies - https://itch.io/queue/c/844603/asset-packs?game_id=444209

Boss - https://itch.io/queue/c/844603/asset-packs?game_id=466748

Heart - https://opengameart.org/content/animated-lives

Shield - https://opengameart.org/content/cc0-shield-icons

Campfire - https://itch.io/queue/c/844603/asset-packs?game_id=526774

Game background, tiles, decorations - https://itch.io/queue/c/844603/asset-packs?game_id=510121

Menu background - https://vnitti.itch.io/grassy-mountains-parallax-background

Intro and Ending background - https://edermunizz.itch.io/free-pixel-art-forest

### AUDIO
Background Music - https://nicole-lyria.itch.io/medieval-rpg-themes

Campfire - https://opengameart.org/content/items-door-fire-weapon-hits

Attack - https://leohpaz.itch.io/minifantasy-dungeon-sfx-pack

Hurt - https://leohpaz.itch.io/minifantasy-dungeon-sfx-pack

Jump - https://leohpaz.itch.io/minifantasy-dungeon-sfx-pack

Shield - https://opengameart.org/content/items-door-fire-weapon-hits

Roll - https://leohpaz.itch.io/minifantasy-dungeon-sfx-pack

Menu Cursor move - https://opengameart.org/content/10-retro-rpg-menu-sounds

Menu Select - https://opengameart.org/content/10-retro-rpg-menu-sounds

Menu Back - https://opengameart.org/content/10-retro-rpg-menu-sounds

Menu Coin input - https://opengameart.org/content/10-retro-rpg-menu-sounds

Menu Pause - https://opengameart.org/content/10-retro-rpg-menu-sounds

Menu Denied - https://opengameart.org/content/10-retro-rpg-menu-sounds
