import pygame
from states.menu import Menu
from helper_function import *
from constants import *


class ControlsMenu(Menu):
    def __init__(self, game):
        Menu.__init__(self, game)
        self.surfacesSetup = False
        self.backgroundSurface = pygame.Surface((SURFACE_WIDTH, SURFACE_HEIGHT))

    def surface_setup(self):
        forest_img = pygame.image.load('images/Background/Grassy_Mountains_preview_fullcolor.png').convert_alpha()
        forest_img = pygame.transform.scale(forest_img, (SURFACE_WIDTH, SURFACE_HEIGHT))
        draw_bg(forest_img, self.backgroundSurface)
        controls_text_surf = create_text_surf('Controls', 'slkscrb.ttf', 30, WHITE)
        self.backgroundSurface.blit(controls_text_surf, (SURFACE_WIDTH / 3, SURFACE_HEIGHT / 8))
        self.surfacesSetup = True

    def display_menu(self):
        self.check_input()
        self.game.displayedSurface.blit(self.backgroundSurface, (0, 0))
        self.blit_screen()

    def check_input(self):
        if self.game.BACK_KEY:
            self.game.menu_screen = True
            self.game.controls_screen = False
