import pygame
from states.menu import Menu
from helper_function import draw_bg, create_text_surf
from constants import *
from components.world import World
#from setup import *


class PauseMenu(Menu):
    def __init__(self, game):
        Menu.__init__(self, game)
        self.state = "Resume"
        self.surfaces_loaded = False
        self.resumex, self.resumey = 0.85 * self.mid_w, 0.75*self.mid_h
        self.quitx, self.quity = 0.85 * self.mid_w, 1*self.mid_h
        self.cursor_rect = pygame.Rect(0, 0, 30, 30)
        self.cursor_surf = create_text_surf('*', self.game.font_name, 30, WHITE)
        self.cursor_rect.midtop = (self.resumex + self.offset, self.resumey)
        self.menu_surface = pygame.Surface((SURFACE_WIDTH, SURFACE_HEIGHT)).convert_alpha()
        self.menu_surface.fill((0, 0, 0, 255))
        # tmp = pygame.Surface((SURFACE_WIDTH, SURFACE_HEIGHT), pygame.SRCALPHA)
        # tmp.fill((255, 255, 255, 0))
        # self.menu_surface.blit(tmp, (0, 0), special_flags=pygame.BLEND_RGBA_MULT)
        self.pause_menu_text_surf = create_text_surf('Paused', 'slkscrb.ttf', 30, WHITE)
        self.resume_text_surf = create_text_surf("Resume", self.game.font_name, 30, WHITE)
        self.quit_text_surf = create_text_surf("Quit", self.game.font_name, 30, WHITE)
        self.menu_surface.blit(self.pause_menu_text_surf, (SURFACE_WIDTH * 0.4, SURFACE_HEIGHT / 8))
        self.menu_surface.blit(self.resume_text_surf, (self.resumex, self.resumey))
        self.menu_surface.blit(self.quit_text_surf, (self.quitx, self.quity))
        self.oldDisplayedSurface = pygame.Surface((SURFACE_WIDTH, SURFACE_HEIGHT)).convert_alpha()


    def load_surfaces(self):
        # self.menu_surface.fill((0, 0, 0, 255))
        # tmp = pygame.Surface((SURFACE_WIDTH, SURFACE_HEIGHT), pygame.SRCALPHA)
        # tmp.fill((255, 255, 255, 0))
        # self.menu_surface.blit(tmp, (0, 0), special_flags=pygame.BLEND_RGBA_MULT)
        #print("loading_old_surface")
        #self.oldDisplayedSurface.blit(old_surface, (0,0))
        self.surfaces_loaded = True

    def display_menu(self):
        self.check_input()
        #self.game.displayedSurface.blit(self.oldDisplayedSurface, (0,0))
        self.game.displayedSurface.blit(self.menu_surface, (0,0))
        self.game.displayedSurface.blit(self.cursor_surf, self.cursor_rect)
        self.blit_screen()

    def move_cursor(self):
        if self.game.DOWN_KEY or self.game.UP_KEY:
            if self.state == 'Resume':
                self.cursor_rect.midtop = (self.quitx + self.offset, self.quity)
                self.state = 'Quit'
            elif self.state == 'Quit':
                self.cursor_rect.midtop = (self.resumex + self.offset, self.resumey)
                self.state = 'Resume'

    def check_input(self):
        self.move_cursor()
        if self.game.START_KEY:
            self.surfaces_loaded = False
            self.game.pause_menu_screen = False
            if self.state == 'Quit':
                self.state = 'Resume'
                self.cursor_rect.midtop = (self.resumex + self.offset, self.resumey)

                #Reset world, dont know if this is the right place
                self.game.world.reset_level()
                self.game.level = 0
                self.game.world = World()
                self.game.world.load_data(f'map/levels/level{self.game.level}_data.csv')
                if INPUT_METHOD == "JOYSTICK":
                    self.game.player, self.game.boss = self.game.world.process_data(self.game.level, self.game.joystick_player_1)
                else:
                    self.game.player, self.game.boss = self.game.world.process_data(self.game.level)
                # reset game variables
                self.game.moving_right = False
                self.game.moving_left = False
                self.game.scroll_total = 0
                self.game.screen_scroll = 0
                # reset keys
                self.game.reset_keys()

                self.game.menu_screen = True
            #self.run_display = False
